/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Controller;

import LoginDb.DbHandler;
import java.io.IOException;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.SQLException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 *
 * @author 986137
 */
public class SellPurchaseAdjustmentServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        Connection con = null;
        CallableStatement proc = null;
        String message = "";
        HttpSession session = request.getSession();
        
        String pacsId = session.getAttribute("pacsId").toString();
        String userId = session.getAttribute("user").toString();
        
        String handleId = request.getParameter("handle_id");
        //String purchaseRef = request.getParameter("orderno");
        //String salesNo = request.getParameter("salesrefno");

        try {
            con = DbHandler.getDBConnection();
            
            if ("purchase".equalsIgnoreCase(handleId)) 
            {                
                try {
                    proc = con.prepareCall("{ call TRADING_OPERATION.update_trading_stock_on_purchase_reject(?,?,?,?) }");
                } catch (SQLException ex) {
                    System.out.println("Error occurred during processing.");
                }          

                proc.setString(1, purchaseRef);
                proc.setString(2, pacsId);
                proc.setString(3, userId);
                proc.registerOutParameter(4, java.sql.Types.VARCHAR);
            
            } else if ("stock".equalsIgnoreCase(handleId)) 
            {                
                try {
                    proc = con.prepareCall("{ call TRADING_OPERATION.update_trading_stock_on_sale_reject(?,?,?,?) }");
                } catch (SQLException ex) {
                    System.out.println("Error occurred during processing.");
                }          

                proc.setString(1, salesNo);
                proc.setString(2, pacsId);
                proc.setString(3, userId);
                proc.registerOutParameter(4, java.sql.Types.VARCHAR);
            }
            
            proc.execute();
           // message = proc.getString(4);

        } catch (SQLException ex) {
           System.out.println("Error occurred during processing.");
        } finally {
            try {
                proc.close();
            } catch (SQLException e) {
                System.out.println("Error occurred during proc close.");
            }
            try {
                con.close();
            } catch (SQLException ex) {
               System.out.println("Error occurred during connection close.");
            }

            request.setAttribute("message", message);
            request.getRequestDispatcher("/Trading_JSP/SellPurchaseAdjustment.jsp").forward(request, response);

        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
